From d6c69912c2a30f07f484c0e14a012d0b809521b1 Mon Sep 17 00:00:00 2001
From: Peter Vreman <peter.vreman@acision.com>
Date: Mon, 24 Aug 2009 15:40:32 +0200
Subject: [PATCH] enable sorting of lists

---
 web/cobbler_web/templates/generic_list.tmpl |   12 +++++++-
 web/cobbler_web/views.py                    |   35 +++++++++++++++++++++++---
 2 files changed, 41 insertions(+), 6 deletions(-)

diff --git a/web/cobbler_web/templates/generic_list.tmpl b/web/cobbler_web/templates/generic_list.tmpl
index fa92761..f8865d6 100644
--- a/web/cobbler_web/templates/generic_list.tmpl
+++ b/web/cobbler_web/templates/generic_list.tmpl
@@ -113,8 +113,16 @@ function action_multi(otype, action, param) {
         <td>
           &nbsp;<input type="checkbox" id="itemsall" onclick="javascript:items_check_all();">
         </td>
-        {% for column_name in columns %}
-        <td align="left"><strong>{{ column_name|title }}</strong></td>
+        {% for value in columns %}
+        <td align="left">
+          <strong><a href="/cobbler_web/{{ what }}/modifylist/sort/{{ value.0 }}">{{ value.0|title }}</a></strong>
+          {% ifequal value.1 "asc" %}
+          &darr;
+          {% endifequal %}
+          {% ifequal value.1 "desc" %}
+          &uarr;
+          {% endifequal %}
+        </td>
         {% endfor %}
         <td align="left"><strong>Actions</strong></td>
       </tr>
diff --git a/web/cobbler_web/views.py b/web/cobbler_web/views.py
index 9cb7bd7..b45019d 100644
--- a/web/cobbler_web/views.py
+++ b/web/cobbler_web/views.py
@@ -217,6 +217,34 @@ def __tweak_field(fields,field_name,attribute,value):
 #==================================================================================
 
 
+def __format_columns(column_names,sort_field):
+    """
+    Format items retrieved from XMLRPC for rendering by the generic_edit template
+    """
+    dataset = []
+
+    # Default is sorting on name    
+    if sort_field is not None:
+        sort_name = sort_field
+    else:
+        sort_name = "name"
+    
+    if sort_name.startswith("!"):
+        sort_name = sort_name[1:]
+        sort_order = "desc"
+    else:
+        sort_order = "asc"
+
+    for fieldname in column_names:
+        fieldorder = "none"
+        if fieldname == sort_name:
+            fieldorder = sort_order
+        dataset.append([fieldname,fieldorder])
+    return dataset
+
+
+#==================================================================================
+
 def __format_items(items, column_names):
     """
     Format items retrieved from XMLRPC for rendering by the generic_edit template
@@ -249,7 +277,7 @@ def genlist(request, what, page=None):
     if page == None:
         page = int(request.session.get("%s_page" % what, 1))
     limit = int(request.session.get("%s_limit" % what, 50))   
-    sort_field = request.session.get("%s_sort_field" % what, None)  # FIXME: no UI for this?
+    sort_field = request.session.get("%s_sort_field" % what, "name")
     filters = simplejson.loads(request.session.get("%s_filters" % what, "{}"))
     pageditems = remote.find_items_paged(what,filters,sort_field,page,limit)
 
@@ -272,8 +300,7 @@ def genlist(request, what, page=None):
     t = get_template('generic_list.tmpl')
     html = t.render(RequestContext(request,{
         'what'           : what,
-        'otypes'         : [ "name", "repo", "distro", "profile", "image" ], # controls linking in fields
-        'columns'        : columns,
+        'columns'        : __format_columns(columns,sort_field),
         'items'          : __format_items(pageditems["items"],columns),
         'pageinfo'       : pageditems["pageinfo"],
         'filters'        : filters,
@@ -301,7 +328,7 @@ def modify_list(request, what, pref, value=None):
         # FIXME: this isn't exposed in the UI.
 
         # sorting list on columns
-        old_sort = request.session.get("%s_sort_field" % what,"")
+        old_sort = request.session.get("%s_sort_field" % what,"name")
         if old_sort.startswith("!"):
             old_sort = old_sort[1:]
             old_revsort = True
-- 
1.5.5.6

